Package ru.bitel.bgbilling.plugins.dispatch.common.service

# Interface DispatchService

@MTOM public interface DispatchService

- ## Method Summary

  Modifier and Type
  Method
  Description
  `void`
  `addMessageInclusion(DispatchMessage dispatchMessage, jakarta.xml.ws.Holder<jakarta.activation.DataHandler> inclusion, String fileName)`
  Добавляет вложение в сообщение.
  `void`
  `addSubscriptions(String dispatchIds, String contractIds)`
  Добавляет подписки на выбранные рассылки в выбранные договоры.
  `void`
  `deleteContact(int contactId)`
  Удаляет контакт.
  `void`
  `deleteContactType(int contactTypeId)`
  Удаляет тип контакта.
  `void`
  `deleteDispatch(Dispatch dispatch)`
  Удаляет рассылку.
  `void`
  `deleteMessage(DispatchMessage dispatchMessage)`
  Удаление сообщения из рассылки.
  `void`
  `deleteMessageInclusion(DispatchMessage dispatchMessage, BGServerFile inclusion)`
  Удаляет вложение из сообщения.
  `void`
  `deleteSenderType(int id)`
  Удаляет метод отправки по его коду
  `void`
  `deleteSubscription(int subscriptionId)`
  Удаляет подписку
  `List<Subscription>`
  `getActiveSubscriptions(int dispatchId)`
  Возвращает список подписок
  `List<IdTitle>`
  `getAddressParamList()`
  Получение списка адресных параметров, которые заведены в параметрах договорах.
  `String`
  `getContactDefaultValue(int contactTypeId, int contractId)`
  `List<Contact>`
  `getContacts(int contractId)`
  Deprecated.
  Use `getContacts(int, Dispatch)` instead
  `List<Contact>`
  `getContacts(int contractId, Dispatch dispatch)`
  Возвращает список контактов, в том числе контакты из параметров договора.
  `List<ContactType>`
  `getContactTypes()`
  Возвращает список типов контактов
  `List<ContractContact>`
  `getContracts(String name, int typeId)`
  Получение списка договоров по контакту
  `String`
  `getCustomConditionCheckerIfaceName()`
  Получение имени интерфейса проверяльщика условия для пользовательского динамического класса.
  `List<Dispatch>`
  `getDispatchList()`
  Возвращает список всех рассылок.
  `List<BGServerFile>`
  `getMessageInclusions(DispatchMessage dispatchMessage)`
  Возвращает список вложений в сообщение
  `List<DispatchMessage>`
  `getMessageList(int dispatchId, boolean onlyNotSent)`
  Возвращает список сообщения для рассылки
  `SearchResult<DispatchMessageStatistic>`
  `getMessageStatisticList(int contractId, int dispatchId, int messageId, int contactId, Period period, Page page)`
  Получение статистики отправленных сообщений по договору и/или рассылке, и/или сообщению, и/или контакту за определенный период.
  `String`
  `getSenderIfaceClassName()`
  Возвращает имя интерфейса, который должен имплементировать новый создаваемый метод отправки
  `List<SenderType>`
  `getSenderTypes()`
  Возвращает методы отправки
  `List<Subscription>`
  `getSubscriptions(int dispatchId, int contractId)`
  Возвращает список подписок
  `List<String>`
  `installedModuleList()`
  Возвращает имена установленных модулей, сделано для обхода запрета "получения списка модулей"
  `void`
  `setEventForSubscription(int dispatchId, int contractId)`
  Устанавливает подпискам договора флаг события
  `void`
  `updateContact(Contact current)`
  Изменяет\создает новый контакт.
  `void`
  `updateContactType(ContactType current)`
  Изменяет\создает тип контакта
  `void`
  `updateDispatch(Dispatch dispatch)`
  Изменяет\создает рассылку
  `void`
  `updateMessage(DispatchMessage dispatchMessage)`
  Изменяет\создает сообщение
  `void`
  `updateSenderType(SenderType current)`
  Изменяет метод отправки
  `void`
  `updateSubscriptions(Subscription subscription)`
  Изменяет\создает подписку

- ## Method Details

  - ### getDispatchList

    List<Dispatch> getDispatchList() throws ru.bitel.bgbilling.common.BGException
    Возвращает список всех рассылок.
    Returns:
      пустой список, если рассылки еще не были заведены
    Throws:
      `ru.bitel.bgbilling.common.BGException`

  - ### getMessageList

    List<DispatchMessage> getMessageList(int dispatchId, boolean onlyNotSent) throws ru.bitel.bgbilling.common.BGException
    Возвращает список сообщения для рассылки
    Parameters:
      `onlyNotSent` - выбрать только неотправленные
      `did` - код рассылки
    Returns:
      пустой список, если сообщений в рассылке еще нет
    Throws:
      `ru.bitel.bgbilling.common.BGException`

  - ### updateDispatch

    void updateDispatch(Dispatch dispatch) throws ru.bitel.bgbilling.common.BGException
    Изменяет\создает рассылку
    Parameters:
      `dispatch` - рассылка (id invalid input: '<'= 0 для создания новой)

  - ### updateMessage

    void updateMessage(DispatchMessage dispatchMessage) throws ru.bitel.bgbilling.common.BGException
    Изменяет\создает сообщение
    Parameters:
      `dispatchMessage` - сообщение (id invalid input: '<'= 0 для создания нового)
    Throws:
      `ru.bitel.bgbilling.common.BGException`

  - ### getMessageInclusions

    List<BGServerFile> getMessageInclusions(DispatchMessage dispatchMessage) throws ru.bitel.bgbilling.common.BGException
    Возвращает список вложений в сообщение
    Parameters:
      `dispatchMessage` - сообщение
    Returns:
    Throws:
      `ru.bitel.bgbilling.common.BGException`

  - ### addMessageInclusion

    void addMessageInclusion(DispatchMessage dispatchMessage, jakarta.xml.ws.Holder<jakarta.activation.DataHandler> inclusion, String fileName) throws ru.bitel.bgbilling.common.BGException
    Добавляет вложение в сообщение. Нельзя добавлять вложения в отправленные сообщения.
    Parameters:
      `inclusion` - данные для вложения
      `fileName` - имя вложения
      `dm` - сообщение
    Throws:
      `ru.bitel.bgbilling.common.BGException`

  - ### deleteMessageInclusion

    void deleteMessageInclusion(DispatchMessage dispatchMessage, BGServerFile inclusion) throws ru.bitel.bgbilling.common.BGException
    Удаляет вложение из сообщения. Нельзя удалить вложение из отправленного сообщения.
    Parameters:
      `inclusion` - вложение
      `dm` - сообщение
    Throws:
      `ru.bitel.bgbilling.common.BGException`

  - ### deleteDispatch

    void deleteDispatch(Dispatch dispatch) throws ru.bitel.bgbilling.common.BGException
    Удаляет рассылку. Удаление рассылки приводит к удалению всех шаблонов рассылки, всех сообщений рассылки и всех подписок на эту рассылку.
    Parameters:
      `dispatch` - рассылка
    Throws:
      `ru.bitel.bgbilling.common.BGException`

  - ### deleteMessage

    void deleteMessage(DispatchMessage dispatchMessage) throws ru.bitel.bgbilling.common.BGException
    Удаление сообщения из рассылки. Невозможно удалить отправленное сообщение, только если не установлен флаг allow.delete.sent.messages=1 в конфигурации плагина.
    Parameters:
      `dm` - сообщение
    Throws:
      `ru.bitel.bgbilling.common.BGException`

  - ### updateContactType

    void updateContactType(ContactType current) throws ru.bitel.bgbilling.common.BGException
    Изменяет\создает тип контакта
    Parameters:
      `current` - (id invalid input: '<'= 0 для создания нового типа контакта)
    Throws:
      `ru.bitel.bgbilling.common.BGException`

  - ### deleteContactType

    void deleteContactType(int contactTypeId) throws ru.bitel.bgbilling.common.BGException
    Удаляет тип контакта. Тип контакта может быть удален ТОЛЬКО если отсутствуют рассылки с таким типом.
    Parameters:
      `contactTypeId` - код типа контакта
    Throws:
      `ru.bitel.bgbilling.common.BGException`

  - ### getContactTypes

    List<ContactType> getContactTypes() throws ru.bitel.bgbilling.common.BGException
    Возвращает список типов контактов
    Returns:
      пустой список, если типов контактов еще нет
    Throws:
      `ru.bitel.bgbilling.common.BGException`

  - ### getContacts

    @RequestWrapper(className="ru.bitel.bgbilling.plugins.dispatch.common.jaxws.GetContactsOldRequest") @ResponseWrapper(className="ru.bitel.bgbilling.plugins.dispatch.common.jaxws.GetContactsOldResponse") @Deprecated List<Contact> getContacts(int contractId) throws ru.bitel.bgbilling.common.BGException
    Deprecated.
    Use `getContacts(int, Dispatch)` instead
    Throws:
      `ru.bitel.bgbilling.common.BGException`

  - ### getContacts

    List<Contact> getContacts(int contractId, Dispatch dispatch) throws ru.bitel.bgbilling.common.BGException
    Возвращает список контактов, в том числе контакты из параметров договора.
    Parameters:
      `contractId` - код договора
      `dispatch` -
    Returns:
    Throws:
      `ru.bitel.bgbilling.common.BGException`

  - ### updateContact

    void updateContact(Contact current) throws ru.bitel.bgbilling.common.BGException
    Изменяет\создает новый контакт. Осуществляется проверка на соответствие шаблону типа контакта.
    Parameters:
      `current` - контакт (id invalid input: '<'= 0 для созданиея нового)

  - ### deleteContact

    void deleteContact(int contactId) throws ru.bitel.bgbilling.common.BGException
    Удаляет контакт. Проверяет наличие подписок для контакта перед удалением.
    Parameters:
      `id` -

  - ### getContactDefaultValue

    String getContactDefaultValue(int contactTypeId, int contractId) throws ru.bitel.bgbilling.common.BGException
    Throws:
      `ru.bitel.bgbilling.common.BGException`

  - ### getSubscriptions

    List<Subscription> getSubscriptions(int dispatchId, int contractId) throws ru.bitel.bgbilling.common.BGException
    Возвращает список подписок
    Parameters:
      `dispatchId` - если 0, то возвращает список всех подписок для договора
      `contractId` - если 0, то возвращает список всех подписок на рассылку
    Returns:
      пустой список, если таковых нет
    Throws:
      `ru.bitel.bgbilling.common.BGException`

  - ### getActiveSubscriptions

    List<Subscription> getActiveSubscriptions(int dispatchId) throws ru.bitel.bgbilling.common.BGException
    Возвращает список подписок
    Parameters:
      `dispatchId` - если 0, то возвращает список всех подписок для договора
    Returns:
      пустой список, если таковых нет
    Throws:
      `ru.bitel.bgbilling.common.BGException`

  - ### deleteSubscription

    void deleteSubscription(int subscriptionId) throws ru.bitel.bgbilling.common.BGException
    Удаляет подписку
    Parameters:
      `subscriptionId` - код подписки
    Throws:
      `ru.bitel.bgbilling.common.BGException`

  - ### updateSubscriptions

    void updateSubscriptions(Subscription subscription) throws ru.bitel.bgbilling.common.BGException
    Изменяет\создает подписку
    Parameters:
      `subscription` - (id invalid input: '<'= 0 для создания новой)

  - ### addSubscriptions

    void addSubscriptions(String dispatchIds, String contractIds) throws ru.bitel.bgbilling.common.BGException
    Добавляет подписки на выбранные рассылки в выбранные договоры. Используется в групповой операции. Подписка добавится только в том случае, если в договоре заведен контакт (-ы) с таким же типом контакта, который указан в рассылке.
    Parameters:
      `dispatchIds` - список кодов рассылок через запятую.
      `contractIds` - список кодов договоров через запятую, которым следует добавить подписки на рассылки.
    Throws:
      `ru.bitel.bgbilling.common.BGException`

  - ### getSenderTypes

    List<SenderType> getSenderTypes() throws ru.bitel.bgbilling.common.BGException
    Возвращает методы отправки
    Returns:
    Throws:
      `ru.bitel.bgbilling.common.BGException`

  - ### getSenderIfaceClassName

    String getSenderIfaceClassName()
    Возвращает имя интерфейса, который должен имплементировать новый создаваемый метод отправки
    Returns:

  - ### updateSenderType

    void updateSenderType(SenderType current) throws ru.bitel.bgbilling.common.BGException
    Изменяет метод отправки
    Parameters:
      `current` - создает при id invalid input: '<'= 0
    Throws:
      `ru.bitel.bgbilling.common.BGException`

  - ### deleteSenderType

    void deleteSenderType(int id) throws ru.bitel.bgbilling.common.BGException
    Удаляет метод отправки по его коду
    Parameters:
      `id` -
    Throws:
      `ru.bitel.bgbilling.common.BGException`

  - ### getAddressParamList

    List<IdTitle> getAddressParamList() throws ru.bitel.bgbilling.common.BGException
    Получение списка адресных параметров, которые заведены в параметрах договорах. ИСпользуется в условии отправки по адресу подписчика
    Returns:
      список адресных параметров в виде `IdTitle`
    Throws:
      `ru.bitel.bgbilling.common.BGException`

  - ### getContracts

    List<ContractContact> getContracts(String name, int typeId) throws ru.bitel.bgbilling.common.BGException
    Получение списка договоров по контакту
    Parameters:
      `name` - Строка для поиска
      `typeId` - Id типа контакта
    Returns:
    Throws:
      `ru.bitel.bgbilling.common.BGException`

  - ### getCustomConditionCheckerIfaceName

    String getCustomConditionCheckerIfaceName() throws ru.bitel.bgbilling.common.BGException
    Получение имени интерфейса проверяльщика условия для пользовательского динамического класса.
    Returns:
      полное имя интерфейса, включая имя пакета.
    Throws:
      `ru.bitel.bgbilling.common.BGException`

  - ### setEventForSubscription

    void setEventForSubscription(int dispatchId, int contractId) throws ru.bitel.bgbilling.common.BGException
    Устанавливает подпискам договора флаг события
    Parameters:
      `dispatchId` - код рассылки
      `contractId` - ид договора
    Throws:
      `ru.bitel.bgbilling.common.BGException`

  - ### getMessageStatisticList

    SearchResult<DispatchMessageStatistic> getMessageStatisticList(int contractId, int dispatchId, int messageId, int contactId, Period period, Page page) throws ru.bitel.bgbilling.common.BGException
    Получение статистики отправленных сообщений по договору и/или рассылке, и/или сообщению, и/или контакту за определенный период.
    Parameters:
      `contractId` - код договора
      `dispatchId` - код рассылки
      `messageId` - код сообщения из рассылки
      `contactId` - код контакта плагина
      `period` - период, за который нужно вывести статистику
      `page` - отображаемая страница
    Throws:
      `ru.bitel.bgbilling.common.BGException`

  - ### installedModuleList

    List<String> installedModuleList() throws ru.bitel.bgbilling.common.BGException
    Возвращает имена установленных модулей, сделано для обхода запрета "получения списка модулей"
    Returns:
    Throws:
      `ru.bitel.bgbilling.common.BGException`